{-# LANGUAGE DeriveAnyClass #-}
module Horizon.Spec.Types.PackageSet (PackageSet(MkPackageSet), compiler, packages) where

import           Data.Kind                      (Type)
import           Dhall                          (FromDhall, Generic, ToDhall)
import           Horizon.Spec.Types.Compiler    (Compiler)
import           Horizon.Spec.Types.PackageList (PackageList)

type PackageSet :: Type
data PackageSet where
  MkPackageSet :: { compiler :: Compiler
                  , packages :: PackageList } -> PackageSet
  deriving stock (Show, Eq, Generic)
  deriving anyclass (FromDhall, ToDhall)
